/*

	Script for installing updated 3D Printer Profiles
	gExistingProfileArray contains a list of the old profiles to be removed
	Zip file of new profiles should be the same name as this script + ".zip"
	
*/

var gExistingProfileArray = new Array ( 
"SeeMeCNC Rostock Max.3PP"
);

var strError = localize("$$$/S4W/Dialog/Browsers/Item/NotFound=File Not Found");

function CreateNewDocument()
{
	// =======================================================
var idMk = charIDToTypeID( "Mk  " );
    var desc1 = new ActionDescriptor();
    var idNw = charIDToTypeID( "Nw  " );
        var desc2 = new ActionDescriptor();
        var idMd = charIDToTypeID( "Md  " );
        var idRGBM = charIDToTypeID( "RGBM" );
        desc2.putClass( idMd, idRGBM );
        var idWdth = charIDToTypeID( "Wdth" );
        var idRlt = charIDToTypeID( "#Rlt" );
        desc2.putUnitDouble( idWdth, idRlt, 504.000000 );
        var idHght = charIDToTypeID( "Hght" );
        var idRlt = charIDToTypeID( "#Rlt" );
        desc2.putUnitDouble( idHght, idRlt, 360.000000 );
        var idRslt = charIDToTypeID( "Rslt" );
        var idRsl = charIDToTypeID( "#Rsl" );
        desc2.putUnitDouble( idRslt, idRsl, 72.000000 );
        var idpixelScaleFactor = stringIDToTypeID( "pixelScaleFactor" );
        desc2.putDouble( idpixelScaleFactor, 1.000000 );
        var idFl = charIDToTypeID( "Fl  " );
        var idFl = charIDToTypeID( "Fl  " );
        var idWht = charIDToTypeID( "Wht " );
        desc2.putEnumerated( idFl, idFl, idWht );
        var idDpth = charIDToTypeID( "Dpth" );
        desc2.putInteger( idDpth, 8 );
        var idprofile = stringIDToTypeID( "profile" );
        desc2.putString( idprofile, "sRGB IEC61966-2.1" );
    var idDcmn = charIDToTypeID( "Dcmn" );
    desc1.putObject( idNw, idDcmn, desc2 );
    executeAction( idMk, desc1, DialogModes.NO );


}
function CloseWithoutSave()
{
// =======================================================
var idClssp = charIDToTypeID( "Cls " );
    var desc30 = new ActionDescriptor();
    var idSvng = charIDToTypeID( "Svng" );
    var idYsNsp = charIDToTypeID( "YsN " );
    var idNspspsp = charIDToTypeID( "N   " );
    desc30.putEnumerated( idSvng, idYsNsp, idNspspsp );
executeAction( idClssp, desc30, DialogModes.NO );

}
function ResetPrintProfiles()
{
	var desc3 = new ActionDescriptor();
	executeAction( stringIDToTypeID( "setPrint3DProperties" ), desc3, DialogModes.NO );
}


function CopyProfiles(srcFolderPath, destFolderPath)
{
	var sourceFolder = new Folder(srcFolderPath);
	if(sourceFolder == null) {
		return 1;
	}
	
	var profileFilesArray = sourceFolder.getFiles();
	var index;
	for(index = 0; index < profileFilesArray.length; index++)
	{
		if(profileFilesArray[index].exists)
		{
			var destFilePath = destFolderPath + profileFilesArray[index].name;
			profileFilesArray[index].copy(destFilePath);
		}
	}
	
	return 0;
}

function DeleteExistingProfiles(printerProfilesPath, profilesToDelete)
{
	var index;
	var numProfiles = profilesToDelete.length;
	for(index = 0; index < numProfiles; index++)
	{
		var profilePath = printerProfilesPath + profilesToDelete[index];
		var dataFile = new File(profilePath);
		if(dataFile == null) {
			continue;
		}
		if(dataFile.exists)
			dataFile.remove();
	}
}

function InstallProfiles()
{
	var printerProfilesPath = app.path + "/Presets/3D Printers/";
	var sourceProfilesPath = $.fileName.slice(0, -4);
	
	
	//Copy the profiles into the 3D Printer folder
	if(CopyProfiles(sourceProfilesPath, printerProfilesPath) == 0)
	{
		//Go through the outdated profile list and delete them
		DeleteExistingProfiles(printerProfilesPath, gExistingProfileArray);
	
		//Have the UI refresh what profiles are installed
		CreateNewDocument();
		ResetPrintProfiles();
		CloseWithoutSave();
		
	}
	else
		alert(strError);
}

InstallProfiles();